# coding: utf-8

"""
    Lead Scraping Service API

    Vector Lead Scraping Service API - Manages Lead Scraping Jobs

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@vector.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateWorkspaceRequest1(BaseModel):
    """
    CreateWorkspaceRequest1
    """ # noqa: E501
    account_id: Optional[StrictStr] = Field(default=None, alias="accountId")
    name: StrictStr
    storage_quota: Optional[StrictStr] = Field(default=None, alias="storageQuota")
    allow_public_sharing: Optional[StrictBool] = Field(default=None, alias="allowPublicSharing")
    require_approval: Optional[StrictBool] = Field(default=None, alias="requireApproval")
    gdpr_compliant: Optional[StrictBool] = Field(default=None, alias="gdprCompliant")
    hipaa_compliant: Optional[StrictBool] = Field(default=None, alias="hipaaCompliant")
    __properties: ClassVar[List[str]] = ["accountId", "name", "storageQuota", "allowPublicSharing", "requireApproval", "gdprCompliant", "hipaaCompliant"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateWorkspaceRequest1 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateWorkspaceRequest1 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountId": obj.get("accountId"),
            "name": obj.get("name"),
            "storageQuota": obj.get("storageQuota"),
            "allowPublicSharing": obj.get("allowPublicSharing"),
            "requireApproval": obj.get("requireApproval"),
            "gdprCompliant": obj.get("gdprCompliant"),
            "hipaaCompliant": obj.get("hipaaCompliant")
        })
        return _obj


