# coding: utf-8

"""
    Lead Scraping Service API

    Vector Lead Scraping Service API - Manages Lead Scraping Jobs

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@vector.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from playbookmedia_backend_client_sdk.models.file_metadata import FileMetadata
from typing import Optional, Set
from typing_extensions import Self

class FolderMetadata(BaseModel):
    """
    FolderMetadata
    """ # noqa: E501
    id: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    s3_bucket_name: Optional[StrictStr] = Field(default=None, alias="s3BucketName")
    s3_folder_path: Optional[StrictStr] = Field(default=None, alias="s3FolderPath")
    is_deleted: Optional[StrictBool] = Field(default=None, alias="isDeleted")
    parent_folder_id: Optional[StrictStr] = Field(default=None, alias="parentFolderId")
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    updated_at: Optional[datetime] = Field(default=None, alias="updatedAt")
    deleted_at: Optional[datetime] = Field(default=None, alias="deletedAt")
    child_folders: Optional[List[FolderMetadata]] = Field(default=None, alias="childFolders")
    files: Optional[List[FileMetadata]] = None
    __properties: ClassVar[List[str]] = ["id", "name", "s3BucketName", "s3FolderPath", "isDeleted", "parentFolderId", "createdAt", "updatedAt", "deletedAt", "childFolders", "files"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FolderMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in child_folders (list)
        _items = []
        if self.child_folders:
            for _item in self.child_folders:
                if _item:
                    _items.append(_item.to_dict())
            _dict['childFolders'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in files (list)
        _items = []
        if self.files:
            for _item in self.files:
                if _item:
                    _items.append(_item.to_dict())
            _dict['files'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FolderMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "s3BucketName": obj.get("s3BucketName"),
            "s3FolderPath": obj.get("s3FolderPath"),
            "isDeleted": obj.get("isDeleted"),
            "parentFolderId": obj.get("parentFolderId"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt"),
            "deletedAt": obj.get("deletedAt"),
            "childFolders": [FolderMetadata.from_dict(_item) for _item in obj["childFolders"]] if obj.get("childFolders") is not None else None,
            "files": [FileMetadata.from_dict(_item) for _item in obj["files"]] if obj.get("files") is not None else None
        })
        return _obj

# TODO: Rewrite to not use raise_errors
FolderMetadata.model_rebuild(raise_errors=False)

